#include "SettingObj.h"

CSettings::CSettings()
{
    SetAll();
}

CSettings::~CSettings()
{
    FreeAll();
}

CWorkUnit::CWorkUnit()
{
    SetAll();
}

CWorkUnit::~CWorkUnit()
{
    FreeAll();
}

void CSettings::SetFromWorkUnit(CWorkUnit * pWorkUnit)
{
    if (szPattern)
    {
        xfree(szPattern);
    }
    if (szHash)
    {
        xfree(szHash);
    }
    if (szAlphabet)
    {
        xfree(szAlphabet);
    }
    szAlphabet = xstrdup(pWorkUnit->szAlphabet);
    cAlphabet = pWorkUnit->cAlphabet;
    szHash = xstrdup(pWorkUnit->szHash);

    szPattern = xstrdup(pWorkUnit->szPattern);

    char * szTempSeed = pWorkUnit->szSeed;
    char * szTempPattern = szPattern;
    while (*szTempSeed && *szTempPattern)
    {
        if (*szTempPattern == '?')
        {
            *szTempPattern = *szTempSeed;
            szTempSeed ++;
        }
        szTempPattern ++;
    }

}

void CSettings::FreeAll()
{

    if (szAlphabet)
    {
        xfree(szAlphabet);
    }
    if (szHash)
    {
        xfree(szHash);
    }
    if (szGetURL)
    {
        xfree(szGetURL);
    }
    if (szUser)
    {
        xfree(szUser);
    }
    if (szPattern)
    {
        xfree(szPattern);
    }

}

void CSettings::ResetAll()
{

    FreeAll();
    SetAll();

}

void CSettings::SetAll()
{

    dwThreads = 1;
    nStart = 0;
    nSleepMins = 5;
    nRetries = -1;
    nOutMode = 1;
    bLocalMode = false;
    bSilent = false;
    bLowPri = false;
    nDownloadAtOnce = 1;
    szAlphabet = xstrdup("ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789");
    cAlphabet = strlen(szAlphabet);
    szHash = xstrdup("96F8B204FD99534759A6C11A181EEDDFEB2DF1D4");
    //szGetURL = xstrdup("http://eolson.dyndns.org/dtc/getwork.php");
    //szGetURL = xstrdup("http://eolson.dyndns.org/dclient/getwork.php");
    szGetURL = xstrdup("http://edo.lcs.mit.edu/dclient/getwork.php");
    bShutDown = false;
    szUser = xstrdup("anonymous");
    szPattern = xstrdup("????????");
    nService = 0;
    bReportKKeys = false;
}

void CWorkUnit::FreeAll()
{

    if (szPattern)
    {
        xfree(szPattern);
    }
    if (szWuid)
    {
        xfree(szWuid);
    }
    if (szResultURL)
    {
        xfree(szResultURL);
    }
    if (szNonce)
    {
        xfree(szNonce);
    }
    if (szSeed)
    {
        xfree(szSeed);
    }
    if (szHash)
    {
        xfree(szHash);
    }
    if (szAlphabet)
    {
        xfree(szAlphabet);
    }

}

void CWorkUnit::ResetAll()
{

    FreeAll();
    SetAll();

}

void CWorkUnit::SetAll()
{

    szPattern = NULL;
    szDecodedMatch[0] = 0;
    szWuid = NULL;
    szResultURL = NULL;
    szNonce = NULL;
    szSeed = NULL;
    szHash = 0;
    szAlphabet = NULL;
    cAlphabet = 0;
    dwProof = 0;

}
