#ifndef _LOGGER_H
#define _LOGGER_H

#include <stdio.h>

class Logger
{
 public:

  Logger();
  ~Logger();

  void setFile(FILE *f);
  void setConsole(FILE *f);

  void setLogLevel(int level);
  void logf(int loglevel, char *format, ...);

  /** suggestions: HIGH for error
      MED for info
  */
  static int CRITICAL;
  static int HIGH; // ERROR
  static int MED;  // WARN
  static int LOW;  // INFO
  static int DEBUG;

 private:
  int _loggingLevel;
  FILE *_logFile;
  FILE *_logConsole;
};

#endif
