#include "Table.h"
#include "tabletoform.h"
#include "httppost.h"
#include "ServerRequest.h"
#include "SSocket.h"

ServerRequest::ServerRequest()
{
  _proxy=NULL;
  _proxyport=80;
}

ServerRequest::~ServerRequest()
{
}

void ServerRequest::configureProxy(char *proxy, int port)
{
  if (_proxy!=NULL)
    free(_proxy);

  _proxy=strdup(proxy);
  _proxyport=port;
}

Table *ServerRequest::performRequest(char *url, Table *args)
{
  char *postdata=tabletoform(args);
  SSocket *ss=new SSocket();
  bool okay=true;
  Table *reply=NULL;

  if (!httppost(ss,url,_proxy,_proxyport, postdata))
    {
      okay=false;
      goto cleanup;
    }

  reply=new Table();
  char buffer[1024];

  /** We've made the post request, process the results. **/
  while (ss->gets(buffer,1024))
    {
      //      printf("%s\n",buffer);
      
      if (strstr(buffer,"=")!=NULL)
	{
	  char *equalsign=strstr(buffer,"=");
	  
	  equalsign[0]=0;
	  char *key=buffer;
	  char *value=&equalsign[1];
	  
	  // table will make copies
	  // replace any previous key/value pair.
	  reply->put(key,value); 
	  continue;
	}
    }

 cleanup:
  ss->close();

  free(postdata);
  delete ss;

  return reply;
}
