#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "httppost.h"
#include "SSocket.h"

bool httppost(SSocket *ss, const char *url, const char *proxy, int proxyport, const char *buf)
{
  char *server, *serverend;
  int port=80;

  /* parse the server portion from the url. If there's
   no leading <goo>//, then assume the beginning is the server. */

  if (proxy==NULL)
    {
      // if no proxy, get server and port from URL
      server=strstr(url,"//");
      if (server==NULL)
	return false;
      
      server=&server[2];
      server=strdup(server);
      serverend=strstr(server,":");
      if (serverend!=NULL)
	{
	  port=atoi(&serverend[1]);
	  serverend[0]=0;
	}

      serverend=strstr(server,"/");
      if (serverend!=NULL)
	serverend[0]=0;
    }
  else
    {
      server=strdup(proxy);
      port=proxyport;
    }

  if (ss->connect(server,port))
    return false;

  ss->printf("POST %s HTTP/1.0\n",url);
  ss->printf("Accept: */*\n");
  ss->printf("User-Agent: edHTTPc\n");
  ss->printf("Host: %s\n",server);
  ss->printf("Content-Type: application/x-www-form-urlencoded\n");
  ss->printf("Content-Length: %i\n",strlen(buf));
  ss->printf("\n");
  ss->printf("%s\n",buf);

  free(server);

  return true;
}
