<html>
<head>
<title>DClient Stats</title>
<link rel="stylesheet" title="default" href="styles.css" type="text/css">
</head>

<h2 id=title>DClient Statistics</h2>
<P>

<?php

$ago24=time()-86400;

include("dbcommon.php");

$stats=array();

// load all of the experiments into an array.
$exps=array();
$query="select * from experiments";
$res=mysql_query($query);

while ($row=mysql_fetch_assoc($res))
{
  $exps[$row["id"]]=$row;
}

// show progress of all experiments.
// first, how many points in each experiment?
$query="select sum(points), experiment from workunits group by experiment";
$res=mysql_query($query);
$stats["pointstotal"]=0;
while ($row=mysql_fetch_assoc($res))
{
  $exps[$row["experiment"]]["pointstotal"]=$row["sum(points)"];
  $stats["pointstotal"]+=$row["sum(points)"];
}

// how many points are done?
$query="select sum(points), experiment from workunits where count>0 group by experiment";
$res=mysql_query($query);
$stats["totalpointsdone"]=0;
while ($row=mysql_fetch_assoc($res))
{
  $exps[$row["experiment"]]["pointsdone"]=$row["sum(points)"];
  $stats["totalpointsdone"]+=$row["sum(points)"];
}

// how many points did we do in last 24 hours?
$query="select sum(points), count(distinct ipaddr) as nips, count(distinct credituser) as users from workunits where count>0 and timefinished>$ago24";
$res=mysql_query($query);
$row=mysql_fetch_assoc($res);
$stats["pointsdone24"]=$row["sum(points)"];
$stats["ips24"]=$row["nips"];
$stats["users24"]=$row["users"];

//************************
// start output
//************************

print "<table width=100% border=0>";
print "<tr><td><h2 id=heading>Experiment Status</h2><td><h2 id=heading>Top Users</h2>";
print "<tr><td valign=top>";
doExperimentStatus($exps);
print "<br>";
doCPUtime($stats);
print "<P><b>Announcement:</b> If you're using the windows client, version 2.03 or older, please <a href=index.php>upgrade!</a> There's a bug that has been fixed in subsequent versions.<br>";

print "<td align=right valign=top>";
doTopUsers();
doUserStatsForm();
print "</table>";
print "<h2 id=heading>Last 24 hours</h2>";
doLast24($stats,$exps);
?>

<hr>
<?php include("footer.php"); ?>
<div align=right><I>Last updated <?php print date("r") ?>. (updates every 15 minutes)</I></div>

<?php

//************************
// end output
//************************

// log results to log file
$fd=fopen("/var/tmp/dclient/stats.log","a");
flock($fd,LOCK_EX);
fwrite($fd,serialize($stats)."\n");
flock($fd,LOCK_UN);
fclose($fd);

function doUserStatsForm()
{
  print "<form method=GET action=userstats.php>";
  print "Get stats for user: ";
  print "<input type=text size=20 name=USERID>";
  print "<input type=submit value=Go>";
  print "</form>";
}

function doExperimentStatus($exps)
{
  print "<table border=1 cellpadding=4 cellspacing=0 width=100%>";
  reset($exps);
  print "<tr><td><b>Pattern</b><td><b>Done</b><td><b>Total</b><td><b>Progress</b>";
  
  while(list($exp,$expar)=each($exps))
    {
      print "<tr><td>$expar[name]<td>";
      print doSciNot($expar["pointsdone"]);
      print "<td>";
      print doSciNot($expar["pointstotal"]);
      print "<td>";
      doBarGraph(150,100*$expar["pointsdone"]/$expar["pointstotal"]);
    }
  print "</table>";
}

function doBarGraph($width, $percent)
{
  $w=intval($percent*$width/100);
  print "<table width=$width border=1 cellpadding=0 cellspacing=0>";
  print "<tr>";
  print "<td align=left>";
  print "<img src=images/reddot.png height=15 width=$w>";
  print "<img src=images/whitedot.png height=15 width=".($width-$w).">";
  print "</table>";
}

function doTopUsers()
{
  print "<table bgcolor=#dddddd width=100%>";
  print "<tr><th>Overall<th>Last 24 hours";
  print "<tr><td>";
  topUsersHelper("",15,false);
  print "<td>";
  topUsersHelper("and timefinished>".(time()-86400),15,true);
  print "</table>";
}

function doLast24($stats,$exps)
{
  print "<P>In the last 24 hours we have finished $stats[totalpointsdone] points.";
  print "<P>These points came from $stats[ips24] unique IP addresses and $stats[users24] users.";

  $pointsremaining=$stats["pointstotal"]-$stats["totalpointsdone"];
  $pointspersecond=$stats["pointsdone24"]/86400;

  print "<P>We averaged ".round($pointspersecond,2)." points per second.";

  $rawsecs=$pointsremaining/$pointspersecond;

  print "<P>It will take us ".doTime($rawsecs)." to finish at our current rate.";
}

function topUsersHelper($whereclause, $limit, $dopps)
{
  $query="select sum(points) as sumpoints, credituser from workunits where count>0 $whereclause group by credituser order by sumpoints desc limit $limit";
  $res=mysql_query($query);

  print "<table bgcolor=#eeeeee width=100%><tr><td width=50%><B>User</td><td width=50%><b>Points</b>";
  if ($dopps)
    {
      print "<td><b>Points/Sec</b>";
    }

  while ($row=mysql_fetch_assoc($res))
    {
      $w=$row["credituser"];
      print "<tr><td><a href=userstats.php?USERID=".urlencode($w).">$w</a><td>".doSciNot($row["sumpoints"]);

      if ($dopps)
	{
	  print "<td align=center>".round($row["sumpoints"]/86400,2);
	}
    }
  print "</table>";
}

function doTime($seconds)
{
  $years=intval($seconds/(86400*365));
  $seconds-=$years*(86400*365);
  $days=intval($seconds/86400);
  $seconds-=$days*86400;
  $hours=intval($seconds/3600);
  $seconds-=$hours*3600;
  $minutes=intval($seconds/60);

  $s="";

  if ($years>0)
    $s="$years years, ";

  return "$s$days days, $hours hours and $minutes minutes";
}

function doCPUtime($stats)
{
  print "We've used about ".doTime($stats["totalpointsdone"])." of CPU time.<br>";
}

function doSciNot($i,$p=3)
{
  $e=intval(log($i)/log(10));
  $d=$i/(pow(10,$e));
  $d=round($d,$p);

  return "$d*10<sup>$e</sup>";
}
  