#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <tchar.h>
#include <stdlib.h>
#include <malloc.h>

#if defined(DEBUG) || defined(_DEBUG)
struct MEM_REF;
void* MyMalloc(UINT s, UINT l, char * f);
void MyMalloc2(LPVOID s, UINT l, char * f);
void MyFree(LPVOID lpv);
void MyFree2(LPVOID lpv);
void MyReport();
void MyInit();
char* MyStrDup(char * szIn, UINT l, char * f);

#define xtrack_init() MyInit()
#define xtrack_dump() MyReport()
#define xmalloc(s) MyMalloc(s, __LINE__, __FILE__)
#define xtrack(s) MyMalloc2(s, __LINE__, __FILE__)
#define xuntrack(s) MyFree2(s)
#define xfree(s) MyFree(s)
#define xstrdup(s) MyStrDup(s, __LINE__, __FILE__);
#else
#define xmalloc(s) malloc(s)
#define xfree(s) free(s)
#define xtrack(s) void()
#define xuntrack(s) void()
#define xtrack_init() void()
#define xtrack_dump() void()
#define xstrdup(s) strdup(s)
#endif
